
Require Import Tactics.
Require Import Sequence.
Require Import Relation.
Require Import Subst.
Require Import Static.
Require Import Dynamic.
Require Import TSubst.
Require Import ProveSubof.
Require Import Formation.
Require Import Determinism.
Require Import Inversion.
Require Import Regularity.
Require Import Preservation.
Require Import Closure.
Require Import Congruence.
Require Import Contextual.
Require Import Equivalence.
Require Import Reductive.
Require Import Translation.
Require Import Split.


Lemma snd_ceq_o :
  forall G T k t M M' c e,
    wf G
    -> split T k t
    -> ceqm G pure M M' T
    -> fstm G M c
    -> snd T M e
    -> exists e',
         snd T M' e'
         /\ ceqt G e e' (subst1 c t).
Proof.
intros G T k t M M' c e Hwf Hsplit Hceq HfstM HsndM.
so (ceqm_reg _#5 Hwf Hceq) as (HofM & _).
so (ofm_reg _#4 Hwf HofM) as HofT.
so (split_fsts _#3 Hsplit) as Hfst.
so (can_snd _ (var 0) (subst_hsg (sh 2) _ (ofs_hsg _ _ HofT))) as (f & Hsnd).
so (subst_snd _#3 (dot M (dot c id)) Hsnd) as HsndMa.
simp_sub in HsndMa.
so (snd_fun _#4 HsndM HsndMa); subst e; clear HsndMa.
so (subst_snd _#3 (dot M' (dot c id)) Hsnd) as HsndM'.
simp_sub in HsndM'.
exists (subst (dot M' (dot c id)) f).
split; auto; [].
clear HsndM HsndM'.
#6 eexploit (snd_formation (G; cl_cn k; cl_md (shift1 T) (var 0)) (subst (sh 2) T) (var 0)) as Hoff.
  auto using wf; done.

  ofvar; done.

  exact Hsnd.

  apply subst_split; eauto; done.

  ofvar; done.
simp_sub in Hoff.
simp_sub in Hoff.
rewrite -> subst_dot1_sh in Hoff; [].
so (ofm_fst _#6 Hwf HofM HfstM Hfst) as Hofc.
replsub (subst1 c t) with (subst (dot M (dot c id)) (shift1 t)).
#2 eapply (funct_ceq_tm _ (G; cl_cn k; cl_md (shift1 T) (var 0))); eauto.
  auto using wf; done.
prove_subrel; auto using eqc_refl; done.
Qed.


Lemma snd_ceq :
  forall G T k t M M' c e e',
    wf G
    -> split T k t
    -> ceqm G pure M M' T
    -> fstm G M c
    -> snd T M e
    -> snd T M' e'
    -> ceqt G e e' (subst1 c t).
Proof.
intros G T k t M M' c e e' Hwf Hsplit Hceqm Hfst Hsnd Hsnd'.
so (snd_ceq_o _#8 Hwf Hsplit Hceqm Hfst Hsnd) as (e'' & Hsnd'' & Hceqt).
so (snd_fun _#4 Hsnd' Hsnd''); subst e''.
exact Hceqt.
Qed.


Lemma snd_ceq_2 :
  forall G T k t M M' c e e',
    wf G
    -> split T k t
    -> ceqm G pure M M' T
    -> fstm G M' c
    -> snd T M e
    -> snd T M' e'
    -> ceqt G e e' (subst1 c t).
Proof.
intros G T k t M M' c' e e' Hwf Hsplit Hceqm HfstM' Hsnd Hsnd'.
so (ceqm_fst _#4 Hwf Hceqm) as (ka & c & ca' & Hfsta & HfstM & HfstMa' & Heqc).
so (split_fsts_eq _#4 Hsplit Hfsta); subst ka.
so (fstm_fun _#4 HfstM' HfstMa'); subst ca'; clear HfstMa'.
so (snd_ceq _#9 Hwf Hsplit Hceqm HfstM Hsnd Hsnd') as Hceq.
apply ceqt_comp; eapply tcc_equiv; eauto; [].
so (ofm_reg _#4 Hwf (ceqm_reg _#5 Hwf Hceqm andel)) as HofT.
so (split_formation _#4 HofT Hsplit) as (_ & Hoft).
eapply funct_cn_type; eauto; done.
Qed.


Lemma join_ceq_o :
  forall G T k t c c' e e' M,
    wf G
    -> ofs G T
    -> split T k t
    -> eqc G c c' k
    -> ceqt G e e' (subst1 c t)
    -> join T c e M
    -> exists M',
         join T c' e' M'
         /\ ceqm G pure M M' T.
Proof.
intros G T k t c c' e e' M Hwf HofT Hsplit Heqc Hceq Hjoine.
so (split_formation _#4 HofT Hsplit) as (Hofk & Hoft).
so (split_fsts _#3 Hsplit) as Hfst.
so (can_join _ (var 1) (var 0) (subst_hsg (sh 2) _ (ofs_hsg _ _ HofT))) as (N & Hjoin).
so (subst_join _#4 (dot e (dot c id)) Hjoin) as Hjoinea.
simp_sub in Hjoinea.
so (join_fun _#5 Hjoine Hjoinea); subst M; clear Hjoinea.
so (subst_join _#4 (dot e' (dot c' id)) Hjoin) as Hjoine'.
simp_sub in Hjoine'.
exists (subst (dot e' (dot c' id)) N).
split; auto; [].
#7 eexploit (join_formation (G; cl_cn k; cl_tm t) (subst (sh 2) T) (var 1) (var 0)) as HofN.
  auto using wf; done.

  apply weaken2_ofs; auto; done.

  exact Hjoin.

  apply subst_split; eauto; done.

  ofvar; done.

  simp_sub.
  simp_sub.
  rewrite -> subst_dot1_sh; [].
  ofvar; done.
replsub T with (subst (dot e (dot c id)) (subst (sh 2) T)).
#2 eapply (funct_ceq_md _ (G; cl_cn k; cl_tm t)); eauto.
  auto using wf; done.
prove_subrel; auto; [].
exact (eqc_reg _#4 Hwf Heqc andel).
Qed.


Lemma join_ceq :
  forall G T k t c c' e e' M M',
    wf G
    -> ofs G T
    -> split T k t
    -> eqc G c c' k
    -> ceqt G e e' (subst1 c t)
    -> join T c e M
    -> join T c' e' M'
    -> ceqm G pure M M' T.
Proof.
intros G T k t c c' e e' M M' Hwf HofT Hsplit Heqc Hceqt Hjoin Hjoin'.
so (join_ceq_o _#9 Hwf HofT Hsplit Heqc Hceqt Hjoin) as (e'' & Hjoin'' & Hceqm).
so (join_fun _#5 Hjoin' Hjoin''); subst e''.
exact Hceqm.
Qed.


Lemma join_snd_formation :
  forall G M T c e M',
    wf G
    -> ofm G pure M T
    -> fstm G M c
    -> snd T M e
    -> join T c e M'
    -> ofm G pure M' T.
Proof.
intros G M T c e M' Hwf HofM HfstM Hsnd Hjoin.
so (ofm_reg _#4 Hwf HofM) as HofT.
so (can_split _ (ofs_hsg _ _ HofT)) as (k & t & Hsplit).
so (split_fsts _#3 Hsplit) as Hfst.
so (ofm_fst _#6 Hwf HofM HfstM Hfst) as Hofc.
so (snd_formation _#7 Hwf  HofM Hsnd Hsplit HfstM) as Hofe.
eapply join_formation; eauto using wf_nil.
Qed.


Lemma join_snd_halt_iff :
  forall M T c e M',
    ofm nil pure M T
    -> fstm nil M c
    -> snd T M e
    -> join T c e M'
    -> (mhalt nil M <-> mhalt nil M').
Proof.
intros M T c e M' Hof Hfst Hsnd Hjoin.
transitivity (thalt nil e).
  eapply snd_halt_iff; eauto; done.

  so (can_split _ (ofs_hsg _ _ (ofm_reg _#4 wf_nil Hof))) as (k & t & Hsplit).
  so (snd_formation _#7 wf_nil Hof Hsnd Hsplit Hfst).
  eapply join_halt_iff; eauto using subst_split; done.
Qed.


Lemma join_snd_fst :
  forall M T k c e M',
    ofm nil pure M T
    -> fsts T k
    -> fstm nil M c
    -> snd T M e
    -> join T c e M'
    -> exists c', fstm nil M' c' /\ eqc nil c c' k.
Proof.
intros M T k c e M' HofM Hfst HfstM Hsnd Hjoin.
so (ofm_reg _#4 wf_nil HofM) as HofT.
so (can_split _ (ofs_hsg _ _ HofT)) as (ka & t & Hsplit).
so (split_fsts_eq _#4 Hsplit Hfst); subst ka.
so (ofm_fst _#6 wf_nil HofM HfstM Hfst) as Hofc.
so (snd_formation _#7 wf_nil HofM Hsnd Hsplit HfstM) as Hofe.
exact (join_fst_o _#7 wf_nil HofT Hjoin Hsplit Hofc Hofe).
Qed.


Lemma join_snd_inverse :
  forall G M T c e M',
    ofm G pure M T
    -> fstm G M c
    -> snd T M e
    -> join T c e M'
    -> ceqm G pure M M' T.
Proof.
cut (forall M T c e M',
       ofm nil pure M T
       -> fstm nil M c
       -> snd T M e
       -> join T c e M'
       -> ceqm nil pure M M' T).
  intro Hprop.
  intros G M T c e M' HofM HfstM Hsnd Hjoin.
  apply ceqm_with_wf; [].
  intro Hwf.
  so (ofm_reg _#4 Hwf HofM) as HofT.
  so (can_split _ (ofs_hsg _ _ HofT)) as (k & t & Hsplit).
  so (split_fsts _#3 Hsplit) as Hfst.
  so (snd_formation _#7 Hwf HofM Hsnd Hsplit HfstM) as Hofe.
  so (ofm_fst _#6 Hwf HofM HfstM Hfst) as Hofc.
  so (join_formation _#7 Hwf HofT Hjoin Hsplit Hofc Hofe) as HofM'.
  so (join_fst_o _#7 Hwf HofT Hjoin Hsplit Hofc Hofe) as (c' & HfstM' & Heqc).
  eapply closed_instances_ceqm_pure; eauto; [].
  intros s Hs.
  eapply Hprop; eauto using subst_ofm, subst_fstm, subst_snd, subst_join, subof_aof_dof, subof_aof_tof; done.
exploit (sg_ind_subst
           (fun T =>
              forall M c e M',
                ofm nil pure M T
                -> fstm nil M c
                -> snd T M e
                -> join T c e M'
                -> ceqm nil pure M M' T)) as Hind.

(* one *)
intros M c e M' HofM HfstM Hsnd Hjoin.
apply ceqm_one_ext; eauto using join_snd_formation, join_snd_halt_iff, wf_nil; done.

(* stat *)
intros k M c e M' HofM HfstM Hsnd Hjoin.
so (join_snd_fst _#6 HofM fsts_stat HfstM Hsnd Hjoin) as (c' & HfstM' & Heqc).
eapply ceqm_stat_ext; eauto using join_snd_formation, join_snd_halt_iff, wf_nil; done.

(* dyn *)
intros t M c e M' HofM HfstM Hsnd Hjoin.
invert Hsnd; clear Hsnd; [].
intros <-.
invert Hjoin; clear Hjoin; [].
intros <-.
eapply ceqm_dyn_ext; eauto with static; [].
apply ceqt_symm; [].
apply ceqt_ext_beta; auto with static; done.

(* pigen *)
intros T1 T2 IH1 IH2 M c e M' HofM HfstM Hsnd Hjoin.
so (join_snd_formation _#6 wf_nil HofM HfstM Hsnd Hjoin) as HofM'.
so (join_snd_fst _#6 HofM fsts_pigen HfstM Hsnd Hjoin) as (c' & HfstM' & Heqc).
#2 eapply (ceqm_conditional_pure (mhalt nil M)); eauto using join_snd_formation, fsts_pigen.
  refine (join_snd_halt_iff _#5 _#4 ander); eauto; done.
clear c' HfstM' Heqc.
intro HhaltM.
apply ceqm_pigen_ext; eauto using join_snd_formation, join_snd_halt_iff; [].
intros V b HofV HfstV HvalV.
invert Hjoin; clear Hjoin; [].
intros e1 M2 Hsnd1 Hjoin2 <-.
apply ceqm_symm; [].
invert Hsnd; [].
intros k1 t1 k2 t2 M1 e2 Hsplit1 Hsplit2 Hjoin1 Hsnd2 <-.
so (subst_snd _#3 (dot (var 0) (dot nonsense (dot nonsense (dot (var 3) (dot nonsense (dot nonsense (sh 6))))))) Hsnd2) as H.
simp_sub in H.
so (snd_fun _#4 Hsnd2 H) as Heqe2.
clear H.
so (subst_join _#4 (dot (var 0) (dot (var 1) (dot nonsense (dot nonsense (sh 4))))) Hjoin1) as H.
simp_sub in H.
so (join_fun _#5 Hjoin1 H) as HeqM1.
clear H.
so (subst_snd _#3 (dot (var 0) (dot nonsense (dot nonsense (sh 3)))) Hsnd1) as H.
simp_sub in H.
so (snd_fun _#4 Hsnd1 H) as Heqe1.
clear H.
so (subst_join _#4 (dot (var 0) (dot (var 1) (dot nonsense (dot (var 3) (dot nonsense (sh 5)))))) Hjoin2) as H.
simp_sub in H.
so (join_fun _#5 Hjoin2 H) as HeqM2.
clear H.
rewrite -> Heqe1, -> HeqM2, -> Heqe2, -> HeqM1; [].
rewrite -> Heqe1, -> HeqM2, -> Heqe2, -> HeqM1 in HofM'; [].
clear Heqe1 HeqM2 Heqe2 HeqM1.
#2 eapply ceqm_trans.
  #2 apply reqm_ceqm.
    eapply ofm_appgn; eauto using ofm_forget; done.
  clear HofM'.
  #2 eapply reqm_trans.
    eapply reqm_appgn; [| apply reqm_refl; done].
    #2 eapply reqm_trans.
      eapply reqm_lett; [].
      apply reqt_letm_beta; eauto; done.
    simp_sub.
    apply msteps_reqm; apply star_one; [].
    apply mstep_lett2; auto with dynamic; done.
  
simp_sub.
  #2 eapply reqm_trans.
    eapply reqm_appgn_beta; eauto using mvalue_mhalt.
  simp_sub.
  #2 eapply reqm_trans.
    eapply reqm_unpack; [].
    #2 eapply reqt_trans.
      apply tsteps_reqt; apply star_one; eauto with dynamic; done.
    simp_sub.
    apply reqt_app_beta; [].
    #2 refine (snd_halt_iff _#4 _ (subst_snd _#4 Hsnd1) andel _).
      simp_sub.
      exact HofV.
  
      simp_sub.
      apply mvalue_mhalt; auto; done.
  simp_sub.
  apply reqm_commute_unpack_letm; done.
clear HofM'.
simp_sub.
so (split_fsts _#3 Hsplit1) as Hfst1.
so (split_fsts _#3 Hsplit2) as Hfst2.
invert (ofm_reg _#4 wf_nil HofM); [].
intros k1a _ Hfst1a HofT2.
so (fsts_fun _#3 Hfst1 Hfst1a); subst k1a; clear Hfst1a.
assert (ofm
          (nil; cl_cn (subst (dot b id) k2); cl_md (shift1 (subst1 b T2)) (var 0))
          impure
          (md_unpack
             (tm_pack (var 1)
                (subst
                   (dot (var 0)
                      (dot nonsense
                         (dot nonsense
                            (dot (subst (sh 2) b)
                               (dot nonsense (dot nonsense (sh 2))))))) e2)
                (subst (dot (subst (sh 2) b) (sh 2)) k2)
                (subst (dot (var 0) (dot (subst (sh 3) b) (sh 3))) t2))
             (subst
                (dot (var 0)
                   (dot (var 1)
                      (dot nonsense (dot (subst (sh 4) b) (dot nonsense (sh 4))))))
                M2) (subst (dot (subst (sh 2) b) (sh 2)) T2))
          (subst (sh 2) (subst1 b T2))) as Hofbody.
  simp_sub.
  so (ofm_fst _#6 wf_nil HofV HfstV Hfst1) as Hofb.
  so (wf_md wf_nil (subst1_ofs _#4 Hofb HofT2) (subst_fsts _#2 (dot b id) Hfst2)) as Hwf'; simp_sub in Hwf'.
  #3 eapply ofm_unpack.
    #3 apply oft_pack.
      ofvar; done.

      simp_sub.
      so (subst_snd _#3 (dot (var 0) (dot nonsense (dot nonsense (dot (subst (sh 2) b) (dot nonsense (dot nonsense (sh 2))))))) Hsnd2) as Hsnd2'; simp_sub in Hsnd2'.
      so (subst_split _#3 (dot (subst (sh 2) b) (sh 2)) Hsplit2) as Hsplit2'; simp_sub in Hsplit2'.
      sor (refine (snd_formation _#7 Hwf' _ Hsnd2' Hsplit2' _)) as H; try (ofvar; done); [].
      simp_sub in H.
      exact H.

      so (split_formation _#4 HofT2 Hsplit2) as (_ & Hoft).
      eapply subst_ofc_type; eauto; [].
      prove_subof; [].
      eapply subst_ofc; eauto; prove_subof; done.

    simp_sub.
    so (subst_join _#4 (dot (var 0) (dot (var 1) (dot nonsense (dot (subst (sh 4) b) (dot nonsense (sh 4)))))) Hjoin2) as Hjoin2'; simp_sub in Hjoin2'.
    so (subst_split _#3 (dot (subst (sh 4) b) (sh 4)) Hsplit2) as Hsplit2'; simp_sub in Hsplit2'.
    apply ofm_forget; [].
    so (split_formation _#4 HofT2 Hsplit2) as (Hofk2 & Hoft2).
    #4 refine (join_formation _#7 _ _ Hjoin2' Hsplit2' _ _).
      #2 apply wf_tm.
        apply wf_cn; auto; [].
        eapply subst_ofk; eauto; [].
        prove_subof; [].
        eapply subst_ofc; eauto; prove_subof; done.

        eapply subst_ofc_type; eauto; [].
        prove_subof; [].
        eapply subst_ofc; eauto; prove_subof; done.

      eapply subst_ofs; eauto; [].
      prove_subof; [].
      eapply subst_ofc; eauto; prove_subof; done.

      ofvar; done.

      ofvar; done.

    eapply subst_ofs; eauto; [].
    prove_subof; [].
    eapply subst_ofc; eauto; prove_subof; done.
#2 eapply (ceqm_trans _#3 (md_letm (md_appgn M V) _ _)).
  apply ceqm_symm; [].
  apply ceqm_comp; [].
  #4 eapply mcc_letm.
    apply ceqm_comp; [].
    #2 eapply mcc_appgn; eauto.
      apply ceqm_refl; apply ofm_forget; eauto; done.

      so (IH1 id) as IH1'.
      simp_sub in IH1'.
      #2 eapply IH1'; eauto.
        so (subst_snd _#3 (dot V (dot nonsense (dot nonsense id))) Hsnd1) as Hsnd1'.
        simp_sub in Hsnd1'.
        exact Hsnd1'.

        so (subst_join _#4 (dot (subst (dot V (dot nonsense (dot nonsense id))) e1) (dot b (dot nonsense (dot nonsense id)))) Hjoin1) as Hjoin1'.
        simp_sub in Hjoin1'.
        exact Hjoin1'.

    apply subst_fsts; eauto; done.

    apply ceqm_refl; auto; done.

    apply eqs_refl; [].
    eapply subst1_ofs; eauto; [].
    eapply ofm_fst; eauto using wf_nil; done.
assert (ofm nil impure (md_appgn M V) (subst1 b T2)) as HofMV.
  eapply ofm_appgn; eauto using ofm_forget; done.
assert (ofm nil impure
          (md_letm (md_appgn M V)
             (md_unpack
                (tm_pack (var 1)
                   (subst
                      (dot (var 0)
                         (dot nonsense
                            (dot nonsense
                               (dot (subst (sh 2) b)
                                  (dot nonsense (dot nonsense (sh 2))))))) e2)
                   (subst (dot (subst (sh 2) b) (sh 2)) k2)
                   (subst (dot (var 0) (dot (subst (sh 3) b) (sh 3))) t2))
                (subst
                   (dot (var 0)
                      (dot (var 1)
                         (dot nonsense
                            (dot (subst (sh 4) b) (dot nonsense (sh 4)))))) M2)
                (subst (dot (subst (sh 2) b) (sh 2)) T2)) 
             (subst1 b T2)) (subst1 b T2)) as Hofall.
  #2 eapply ofm_letm; eauto.
    eapply subst_fsts; eauto; done.

    eapply subst1_ofs; eauto; [].
    clear Hofbody HofMV; eapply ofm_fst; eauto using wf_nil; done.
#2 apply (ceqm_conditional_impure (mhalt nil (md_appgn M V))); eauto.
  intro Hhalt.
  exact (mletm_halt_inversion' _#3 Hhalt).
clear Hofbody.
intro Hhalt.
destruct Hhalt as (W & Hsteps & HvalW).
so (mvalue_pure _#4 HvalW (preservations_md _#5 wf_nil HofMV Hsteps)) as HofW.
so (can_fstm _#3 wf_nil HofW) as (a & HfstW).
#2 eapply ceqm_trans.
  apply reqm_ceqm; auto; [].
  clear Hofall.
  #2 eapply reqm_trans.
    apply reqm_letm; [].
    apply msteps_reqm; eauto; done.
  #2 eapply reqm_trans.
    apply msteps_reqm; apply star_one; eapply mstep_letm2; eauto; done.
  simp_sub.
  apply reqm_unpack_beta; [].
  refine (snd_halt_iff _#4 _ (subst_snd _#4 Hsnd2) andel (mvalue_mhalt _  _ _)); auto; [].
  simp_sub.
  exact HofW.
clear Hofall.
simp_sub.
#2 apply (ceqm_trans _#3 W).
  apply ceqm_symm; [].
  apply ceqm_forget_pure; [].
  #2 eapply IH2; eauto.
    so (subst_snd _#3 (dot W (dot nonsense (dot nonsense (dot b (dot nonsense (dot nonsense id)))))) Hsnd2) as Hsnd2'.
    simp_sub in Hsnd2'.
    exact Hsnd2'.

    so (subst_join _#4 (dot (subst (dot W (dot nonsense (dot nonsense (dot b (dot nonsense (dot nonsense id)))))) e2) (dot a (dot nonsense (dot b (dot nonsense id))))) Hjoin2) as Hjoin2'.
    simp_sub in Hjoin2'.
    exact Hjoin2'.
apply ceqm_symm; [].
eapply msteps_ceqm; eauto; done.

(* piapp *)
intros T1 T2 IH1 IH2 M c e M' HofM HfstM Hsnd Hjoin.
so (join_snd_formation _#6 wf_nil HofM HfstM Hsnd Hjoin) as HofM'.
so (can_fsts _ _ (ofm_reg _#4 wf_nil HofM)) as (l & Hfst).
invert Hfst; [].
intros k1 k2 Hfst1 Hfst2 _.
clear l Hfst.
so (join_snd_fst _#6 HofM (fsts_piapp Hfst1 Hfst2) HfstM Hsnd Hjoin) as (c' & HfstM' & Heqc).
#2 eapply (ceqm_conditional_pure (mhalt nil M)); eauto using fsts_piapp.
  refine (join_snd_halt_iff _#5 _#4 ander); eauto; done.
intro HhaltM.
eapply ceqm_piapp_ext; eauto using join_snd_halt_iff, fsts; [].
clear c' HfstM' Heqc k1 k2 Hfst1 Hfst2.
intros V b HofV HfstV HvalV.
invert (ofm_reg _#4 wf_nil HofM); [].
intros k1 HofT1 Hfst1 HofT2.
so (can_snd (subst (sh 2) T1) (var 0) (subst_hsg _ _ (ofs_hsg _ _ HofT1))) as (e1 & Hsnd1).
so (can_join (subst (sh 2) T1) (var 1) (var 0) (subst_hsg _ _ (ofs_hsg _ _ HofT1))) as (M1 & Hjoin1).
so (can_snd (subst (sh 2) T2) (var 0) (subst_hsg _ _ (ofs_hsg _ _ HofT2))) as (e2 & Hsnd2).
so (can_join (subst (sh 2) T2) (var 1) (var 0) (subst_hsg _ _ (ofs_hsg _ _ HofT2))) as (M2 & Hjoin2).
invert Hjoin; clear Hjoin; [].
intros f N Hsnd1x Hjoin2x <-.
so (subst_snd _#3 (under 2 sh1) Hsnd1) as Hsnd1x'.
simp_sub in Hsnd1x'.
so (snd_fun _#4 Hsnd1x Hsnd1x'); subst f.
clear Hsnd1x Hsnd1x'.
so (subst_join _#4 (dot (tm_app (tm_papp (var 2) (var 1)) (subst (dot (var 0) (dot (var 1) (sh 3))) e1)) (dot (cn_app (subst (sh 3) c) (var 1)) (dot (var 1) (sh 3)))) Hjoin2) as Hjoin2x'.
simp_sub in Hjoin2x'.
so (join_fun _#5 Hjoin2x Hjoin2x'); subst N.
clear Hjoin2x Hjoin2x'.
invert Hsnd; clear Hsnd; [].
intros k1a t1 N f Hsplit1 Hjoin1x Hsnd2x <-.
so (split_fsts_eq _#4 Hsplit1 Hfst1); subst k1a.
so (subst_join _#4 (under 2 (sh 2)) Hjoin1) as Hjoin1x'.
simp_sub in Hjoin1x'.
so (join_fun _#5 Hjoin1x Hjoin1x'); subst N.
clear Hjoin1x Hjoin1x'.
so (subst_snd _#3 (dot (md_appap (var 2) (subst (dot (var 0) (dot (var 1) (sh 4))) M1)) (dot nonsense (dot (var 1) (sh 4)))) Hsnd2) as Hsnd2x'.
simp_sub in Hsnd2x'.
so (snd_fun _#4 Hsnd2x Hsnd2x'); subst f.
clear Hsnd2x Hsnd2x'.
simp_sub.
eapply ceqm_symm; [].
#2 eapply ceqm_trans.
  #2 apply reqm_ceqm.
    eapply ofm_appap; eauto; done.
  clear HofM'.
  #2 eapply reqm_trans.
    eapply reqm_appap; [| apply reqm_refl; done].
    #2 eapply reqm_trans.
      apply reqm_lett; [].
      apply reqt_letm_beta; eauto; done.
    simp_sub.
    apply msteps_reqm; apply star_one; apply mstep_lett2; eauto with dynamic; done.
  simp_sub.
  apply msteps_reqm; apply star_one; eapply mstep_appap3; eauto with dynamic; done.
simp_sub.
clear HofM'.
so (can_split _ (ofs_hsg _ _ HofT2)) as (k2 & t2 & Hsplit2).
so (split_fsts _#3 Hsplit2) as Hfst2.
so (split_formation _#4 HofT2 Hsplit2) as (Hofk2 & Hoft2).
so (ofs_fst _#3 HofT1 Hfst1) as Hofk1.
(* Replace the nonsense in e2's substitution with (cn_app c b). I'd rather do it later,
   but there seems to be a skoleming bug in Coq that keeps me from doing it after the
   existentials are created by the ceqm_trans below. *)
so (subst_snd _#3 (dot (var 0) (dot (subst (sh 3) (cn_app c b)) (sh 2))) Hsnd2) as Hsnd2x.
simp_sub in Hsnd2x.
so (snd_fun _#4 Hsnd2 Hsnd2x) as Heqe2.
clear Hsnd2x.
rewrite -> Heqe2; [].
simp_sub.
clear Heqe2.
#2 eapply ceqm_trans.
  replsub (subst1 b T2) with (subst (dot (tm_app (tm_papp (tm_plam k1 (tm_lam t1 (subst (dot (md_appap (subst (sh 2) M) (subst (dot (var 0) (dot (var 1) (sh 2))) M1)) (dot (subst (sh 2) (cn_app c b)) (dot (var 1) (sh 2)))) e2))) b) (subst (dot V (dot b id)) e1)) (dot (cn_app c b) (dot b id))) (subst (sh 2) T2)).
  #4 eapply (funct_ceq_md nil (nil; cl_cn k1; cl_cn k2; cl_tm t2)).
    exact wf_nil.

    auto using wf; done.

    #2 apply subrel_dot.
      #2 apply subrel_dot.
        #2 apply subrel_dot.
          apply subrel_sh; auto with sequence; done.

          simp_sub.
          so (ofm_fst _#6 wf_nil HofV HfstV Hfst1) as Hofb.
          apply deq_cn; eauto with static; done.

        simp_sub.
        so (ofm_fst _#6 wf_nil HofM HfstM (fsts_piapp Hfst1 Hfst2)) as Hofc.
        so (ofm_fst _#6 wf_nil HofV HfstV Hfst1) as Hofb.
        apply deq_cn; eauto with static; done.

      simp_sub.
      apply deq_tm; [].
      so (split_formation _#4 HofT1 Hsplit1) as (_ & Hoft1).
      #2 eapply ceqt_trans.
        #2 apply reqt_ceqt.
          (* well this is quite a mess *)
          #2 eapply oft_app.
            relquest.
              #2 eapply oft_papp.
                eapply oft_plam; eauto using svalue; [].
                eapply oft_lam; auto; [].
                rewrite -> subst_dot01_sh; [].
                #6 eexploit (snd_formation (nil; cl_cn k1; cl_cn k2; cl_md (shift1 T2) (var 0)) (subst (sh 2) T2) (var 0)) as Hofe2.
                  auto using wf; done.

                  ofvar; done.

                  exact Hsnd2.

                  apply subst_split; eauto; done.

                  ofvar; done.
                simp_sub in Hofe2.
                simp_sub in Hofe2.
                rewrite -> subst_dot1_sh in Hofe2; [].
                #7 eexploit (join_fst_o (nil; cl_cn k1; cl_tm t1) (subst (sh 2) T1)) as H.
                  auto using wf; done.

                  apply weaken2_ofs; auto; done.

                  exact Hjoin1.

                  apply subst_split; eauto; done.

                  ofvar; done.

                  simp_sub.
                  simp_sub.
                  rewrite -> subst_dot1_sh; [].
                  ofvar; done.
                destruct H as (d & HfstM1 & Heqd).
                (* replace (cn_app c^2 b^2) with (cn_app c^2 d) in e2 *)
                so (subst_snd _#3 (dot (md_appap (subst (sh 2) M) M1) (dot (cn_app (subst (sh 2) c) (subst (sh 2) b)) (dot (var 1) (sh 2)))) Hsnd2) as Hsnd2x.
                simp_sub in Hsnd2x.
                so (subst_snd _#3 (dot (md_appap (subst (sh 2) M) M1) (dot (cn_app (subst (sh 2) c) d) (dot (var 1) (sh 2)))) Hsnd2) as Hsnd2x'.
                simp_sub in Hsnd2x'.
                so (snd_fun _#4 Hsnd2x Hsnd2x') as Heq.
                rewrite -> Heq; [].
                clear Hsnd2x Hsnd2x' Heq.
                #2 eapply (@oft_equiv _ _ (shift1 (subst (dot (cn_app (shift1 c) (var 0)) (dot (var 0) sh1)) t2))).
                  eapply subst_oft; eauto; [].
                  #3 prove_subof.
                    rewrite -> subst_dot1_sh; [].
                    #2 eapply ofc_subsume.
                      #2 eapply ofc_app.
                        relquest.
                          apply weaken2_ofc; [].
                          eapply (ofm_fst _ _ M); eauto using wf_nil, fsts_piapp; done.

                          simp_sub.
                          reflexivity.
                          
                        refine (eqc_reg _#4 _ Heqd anderl); [].
                        auto using wf; done.

                      simp_sub.
                      apply subk_refl; [].
                      rewrite <- (subst_dot1_sh k2); [].
                      eapply seq_ofk; eauto using wf; [].
                      prove_subrel; [].
                      apply eqc_symm; assumption.

                    #2 eapply ofm_subsume.
                      #3 eapply ofm_appap.
                        relquest.
                          apply weaken2_ofm; eauto; done.

                          simp_sub; reflexivity.
                          
                        #5 eapply join_formation; eauto.
                          auto using wf; done.

                          apply weaken2_ofs; auto; done.

                          apply subst_split; eauto; done.

                          ofvar; done.

                          simp_sub.
                          simp_sub.
                          rewrite -> subst_dot1_sh; [].
                          ofvar; done.

                          exact HfstM1.
                          
                        simp_sub.
                        apply subs_refl; [].
                        eapply seq_ofs; eauto using wf; [].
                        prove_subrel; [].
                        apply eqc_symm; assumption.

                    #2 apply fstm_appap.
                      eapply subst_fstm; eauto; [].
                      prove_subof; done.

                      assumption.

                  simp_sub.
                  eapply seq_ofc_type; eauto using wf; [].
                  #2 prove_subrel.
                    apply eqc_refl; [].
                    ofvar; done.

                    apply eqc_symm; [].
                    relquest.
                      #2 eapply eqc_app.
                        apply eqc_refl; [].
                        relquest.
                          apply weaken2_ofc; [].
                          exact (ofm_fst _#6 wf_nil HofM HfstM (fsts_piapp Hfst1 Hfst2)).

                          simp_sub.
                          reflexivity.

                        assumption.

                      simp_sub.
                      reflexivity.

                eapply ofm_fst; eauto using wf_nil; done.

              simp_sub.
              reflexivity.

            replsub (subst1 b t1) with (subst (dot V (dot b id)) (shift1 t1)).
            #2 eapply (subst_oft _ (nil; cl_cn k1; cl_md (shift1 T1) (var 0))); eauto.
              prove_subof; auto; [].
              eapply ofm_fst; eauto using wf; done.

              #6 eexploit (snd_formation (nil; cl_cn k1; cl_md (shift1 T1) (var 0)) (subst (sh 2) T1) (var 0)) as H.
                auto using wf; done.

                ofvar; done.

                exact Hsnd1.

                apply subst_split; eauto; done.

                ofvar; done.

                simp_sub in H.
                simp_sub in H.
                rewrite -> subst_dot1_sh in H; [].
                exact H.
  
          #2 eapply reqt_trans.
            apply reqt_app; [| apply reqt_refl; done].
            apply tsteps_reqt; [].
            apply star_one; [].
            apply tstep_papp2; done.
          simp_sub.
          apply reqt_app_beta; [].
          #3 refine (snd_halt_iff pure T1 V _ _ _ andel _).
            assumption.
  
            so (subst_snd _#3 (dot V (dot b id)) Hsnd1) as H.
            simp_sub in H.
            exact H.
  
            apply mvalue_mhalt; assumption.
      simp_sub.
      apply ceqt_symm; [].
      replsub (subst (dot (cn_app c b) (dot b id)) t2) with (subst (dot (md_appap M V) (dot (cn_app c b) (dot b id))) (shift1 t2)).
      #4 eapply (funct_ceq_tm nil (nil; cl_cn k1; cl_cn k2; cl_md (shift1 T2) (var 0))).
        exact wf_nil.

        auto using wf; done.

        #2 apply subrel_dot.
          #2 apply subrel_dot.
            #2 apply subrel_dot.
              apply subrel_sh; auto with sequence; done.

              simp_sub.
              so (ofm_fst _#6 wf_nil HofV HfstV Hfst1) as Hofb.
              apply deq_cn; eauto with static; done.

            simp_sub.
            so (ofm_fst _#6 wf_nil HofM HfstM (fsts_piapp Hfst1 Hfst2)) as Hofc.
            so (ofm_fst _#6 wf_nil HofV HfstV Hfst1) as Hofb.
            apply deq_cn; eauto with static; done.

          simp_sub.
          #2 apply deq_md.
            apply ceqm_comp; [].
            eapply mcc_appap; eauto using ceqm_refl; [].
            #5 eexploit (IH1 id V) as H.
              simp_sub; assumption.

              exact HfstV.

              simp_sub.
              so (subst_snd _#3 (dot V (dot b id)) Hsnd1) as H.
              simp_sub in H.
              exact H.

              simp_sub.
              so (subst_join _#4 (dot (subst (dot V (dot b id)) e1) (dot b id)) Hjoin1) as H.
              simp_sub in H.
              exact H.
            
              simp_sub in H.
              exact H.

            auto with static; done.

        #6 eexploit (snd_formation (nil; cl_cn k1; cl_cn k2; cl_md (shift1 T2) (var 0)) (subst (sh 2) T2) (var 0)).
          auto using wf; done.

          ofvar; done.

          exact Hsnd2.

          apply subst_split; eauto; done.

          ofvar; done.

          simp_sub in H.
          simp_sub in H.
          rewrite -> subst_dot1_sh in H; [].
          exact H.

    #7 eexploit (join_formation (nil; cl_cn k1; cl_cn k2; cl_tm t2) (subst (sh 2) T2) (var 1) (var 0)).
      auto using wf; done.

      apply weaken2_ofs; auto; done.

      exact Hjoin2.

      apply subst_split; eauto; done.

      ofvar; done.

      simp_sub.
      simp_sub.
      rewrite -> subst_dot1_sh; [].
      ofvar; done.

      exact H.
simp_sub.
apply ceqm_symm; [].
#4 eapply (IH2 (dot b id)).
  eapply ofm_appap; eauto; done.

  eauto with static; done.

  simp_sub.
  so (subst_snd _#3 (dot (md_appap M V) (dot (cn_app c b) (dot b id))) Hsnd2) as H.
  simp_sub in H.
  exact H.

  simp_sub.
  so (subst_join _#4 (dot (subst (dot (md_appap M V) (dot (cn_app c b) (dot b id))) e2) (dot (cn_app c b) (dot b id))) Hjoin2) as H.
  simp_sub in H.
  exact H.

(* sigma *)
intros T1 T2 IH1 IH2 M c e M' HofM HfstM Hsnd Hjoin.
so (join_snd_formation _#6 wf_nil HofM HfstM Hsnd Hjoin) as HofM'.
so (can_fsts _ _ (ofm_reg _#4 wf_nil HofM)) as (l & Hfst).
invert Hfst; clear Hfst; [].
intros k1 k2 Hfst1 Hfst2 _.
clear l.
so (join_snd_fst _#6 HofM (fsts_sigma Hfst1 Hfst2) HfstM Hsnd Hjoin) as (c' & HfstM' & Heqc).
#2 eapply (ceqm_conditional_pure (mhalt nil M)); eauto using fsts_sigma.
  refine (join_snd_halt_iff _#5 _#4 ander); eauto; done.
intro HhaltM.
clear c' HfstM' Heqc.
invert Hsnd; clear Hsnd; [].
intros e1 e2 Hsnd1 Hsnd2 <-.
invert Hjoin; clear Hjoin; [].
intros M1 M2 Hjoin1 Hjoin2 <-.
assert (thalt nil (subst (dot M (dot c id)) e1)) as Hhalt1.
  so (subst_snd _#3 (dot M (dot c id)) Hsnd1) as Hsnd1x.
  simp_sub in Hsnd1x.
  #2 refine (snd_halt_iff _#4 _ Hsnd1x andel _).
    eapply ofm_pi1; eauto; done.

    eapply mhalt_pi1; eauto; done.
assert (thalt nil (subst (dot M (dot c id)) e2)) as Hhalt2.
    so (subst_snd _#3 (dot M (dot c id)) Hsnd2) as Hsnd2x.
    simp_sub in Hsnd2x.
    #2 refine (snd_halt_iff _#4 _ Hsnd2x andel _).
      eapply ofm_pi2; eauto; done.

      eapply mhalt_pi2; eauto; done.
apply ceqm_symm; [].
#2 eapply ceqm_trans.
  #2 eapply reqm_ceqm.
    exact HofM'.
  #2 eapply reqm_trans.
    apply reqm_lett; [].
    apply reqt_letm_beta; eauto; done.
  simp_sub.
  apply reqm_lett_beta; [].
  apply thalt_pair; auto; done.
simp_sub.
clear HofM'.
invert (ofm_reg _#4 wf_nil HofM); [].
intros k1a HofT1 Hfst1a HofT2.
so (fsts_fun _#3 Hfst1 Hfst1a); subst k1a; clear Hfst1a.
so (can_split _ (ofs_hsg _ _ HofT1)) as (k1a & t1 & Hsplit1).
so (split_fsts_eq _#4 Hsplit1 Hfst1); subst k1a.
so (ofm_fst _#6 wf_nil HofM HfstM (fsts_sigma Hfst1 Hfst2)) as Hofc.
so (can_split _ (ofs_hsg _ _ HofT2)) as (k2a & t2 & Hsplit2).
so (split_fsts_eq _#4 Hsplit2 Hfst2); subst k2a.
assert (oft nil (tm_pair (subst (dot M (dot c id)) e1) (subst (dot M (dot c id)) e2)) (cn_prod (subst1 (cn_pi1 c) t1) (subst (dot (cn_pi2 c) (dot (cn_pi1 c) id)) t2))) as Hofpair.
  #2 apply oft_pair.
    so (subst_snd _#3 (dot M (dot c id)) Hsnd1) as Hsnd1x.
    simp_sub in Hsnd1x.
    exact (snd_formation _#7 wf_nil (ofm_pi1 HofM) Hsnd1x Hsplit1 (fstm_pi1 HfstM)).

    so (subst_snd _#3 (dot M (dot c id)) Hsnd2) as Hsnd2x.
    simp_sub in Hsnd2x.
    so (snd_formation _#7 wf_nil (ofm_pi2 HofM HfstM) Hsnd2x (subst_split _#4 Hsplit2) (fstm_pi2 HfstM)) as H.
    simp_sub in H.
    exact H.
#4 eexploit (join_ceq_o nil T1 k1 t1 (cn_pi1 c) (cn_pi1 c) (tm_pi1 (tm_pair (subst (dot M (dot c id)) e1) (subst (dot M (dot c id)) e2))) (subst (dot M (dot c id)) e1)) as H; auto using wf_nil.
  apply eqc_refl; [].
  eapply ofc_pi1; eauto; done.

  #2 apply reqt_ceqt.
    eapply oft_pi1; eauto; done.

    apply reqt_pi1_beta; auto; done.

  so (subst_join _#4 (dot (tm_pair (subst (dot M (dot c id)) e1) (subst (dot M (dot c id)) e2)) id) Hjoin1) as Hjoin1x.
  simp_sub in Hjoin1x.
  exact Hjoin1x.
destruct H as (M1x & Hjoin1' & Hceq1a).
so (subst_snd _#3 (dot M (dot c id)) Hsnd1) as Hsnd1'.
simp_sub in Hsnd1'.
so (IH1 id) as H.
simp_sub in H.
so (H _#4 (ofm_pi1 HofM) (fstm_pi1 HfstM) Hsnd1' Hjoin1') as Hceq1b.
clear H.
so (ceqm_trans _#6 Hceq1b (ceqm_symm _#5 Hceq1a)) as Hceq1.
clear IH1 M1x Hsnd1' Hjoin1' Hceq1a Hceq1b.
#7 eexploit (join_ceq_o nil (subst1 (cn_pi1 c) T2) (subst1 (cn_pi1 c) k2) (subst (under 1 (dot (cn_pi1 c) id)) t2) (cn_pi2 c) (cn_pi2 c) (tm_pi2 (tm_pair (subst (dot M (dot c id)) e1) (subst (dot M (dot c id)) e2))) (subst (dot M (dot c id)) e2)) as H.
  exact wf_nil.

  eapply subst1_ofs; eauto; [].
  eapply ofc_pi1; eauto; done.

  apply subst_split; eauto; done.

  apply eqc_refl; [].
  eapply ofc_pi2; eauto; done.

  #2 apply reqt_ceqt.
    eapply oft_pi2; eauto; [].
    simp_sub.
    exact Hofpair.

    apply reqt_pi2_beta; auto; done.
    
  so (subst_join _#4 (dot (tm_pair (subst (dot M (dot c id)) e1) (subst (dot M (dot c id)) e2)) id) Hjoin2) as Hjoin2x.
  simp_sub in Hjoin2x.
  exact Hjoin2x.
destruct H as (M2x & Hjoin2' & Hceq2a).
so (subst_snd _#3 (dot M (dot c id)) Hsnd2) as Hsnd2'.
simp_sub in Hsnd2'.
so (IH2 (dot (cn_pi1 c) id) _#4 (ofm_pi2 HofM HfstM) (fstm_pi2 HfstM) Hsnd2' Hjoin2') as Hceq2b.
so (ceqm_trans _#6 Hceq2b (ceqm_symm _#5 Hceq2a)) as Hceq2.
clear IH2 M2x Hsnd2' Hjoin2' Hceq2a Hceq2b.
apply ceqm_symm; [].
#2 eapply ceqm_trans.
  apply ceqm_sigma_eta; auto; done.

  eapply ceqm_pair_dep; eauto with static; done.

(* epilogue *)
intros M T c e M' HofM HfstM Hsnd Hjoin.
eapply Hind; eauto; [].
exact (ofs_hsg _ _ (ofm_reg _#4 wf_nil HofM)).
Qed.


Lemma join_snd_vars_inverse :
  forall G M T c e N,
    ofm G pure M T
    -> fstm G M c
    -> snd (subst sh1 T) (var 0) e
    -> join (subst (sh 2) T) (var 1) (var 0) N
    -> ceqm G pure M (subst (dot (subst (dot M id) e) (dot c id)) N) T.
Proof.
intros G M T c e N HofM HfstM Hsnd Hjoin.
so (subst_snd _#3 (dot M id) Hsnd) as Hsndx; simp_sub in Hsndx.
so (subst_join _#4 (dot (subst (dot M id) e) (dot c id)) Hjoin) as Hjoinx; simp_sub in Hjoinx.
exact (join_snd_inverse _#6 HofM HfstM Hsndx Hjoinx).
Qed.


Lemma join_snd_inverse_fstm_eqc :
  forall G M T k c c' e M',
    ofm G pure M T
    -> fstm G M c
    -> fsts T k
    -> eqc G c c' k
    -> snd T M e
    -> join T c' e M'
    -> ceqm G pure M M' T.
Proof.
intros G M T k c c' e M' HofM HfstM Hfst Heqc Hsnd Hjoinc'.
apply ceqm_with_wf; intro Hwf; [].
so (ofm_reg _#4 Hwf HofM) as HofT.
so (can_split _ (ofs_hsg _ _ HofT)) as (ka & t & Hsplit).
so (split_fsts_eq _#4 Hsplit Hfst); subst ka.
so (split_formation _#4 HofT Hsplit) as (Hofk & Hoft).
so (can_join _ (var 1) (var 0) (subst_hsg (sh 2) _ (ofs_hsg _ _ HofT))) as (N & Hjoin).
so (join_vars_formation _#5 Hwf HofT Hsplit Hjoin) as HofN.
so (subst_join _#4 (dot e (dot c' id)) Hjoin) as H; simp_sub in H.
so (join_fun _#5 H Hjoinc'); subst M'.
clear H Hjoinc'.
so (subst_join _#4 (dot e (dot c id)) Hjoin) as Hjoinc; simp_sub in Hjoinc.
so (join_snd_inverse _#6 HofM HfstM Hsnd Hjoinc) as Hceq.
eapply ceqm_trans; eauto; [].
relquest.
  refine (funct_ceq_md _#7 Hwf (wf_tm (wf_cn Hwf Hofk) Hoft) _ HofN); [].
  #2 apply subrel_deq_ceq_tm.
    #3 eapply subrel_deq_cn.
      exact Hwf.

      apply subrel_id; done.

      simp_sub; auto; done.

    apply ceqt_refl; [].
    exact (snd_formation _#7 Hwf HofM Hsnd Hsplit HfstM).

  simp_sub; reflexivity.
Qed.


Lemma snd_join_formation :
  forall G T k t c e M e',
    wf G
    -> ofs G T
    -> split T k t
    -> ofc G c k
    -> oft G e (subst1 c t)
    -> join T c e M
    -> snd T M e'
    -> oft G e' (subst1 c t).
Proof.
intros G T k t c e M e' Hwf HofT Hsplit Hofc Hofe Hjoin Hsnd.
so (join_formation _#7 Hwf HofT Hjoin Hsplit Hofc Hofe) as HofM.
so (can_fstm _#3 Hwf HofM) as (c' & HfstM).
so (join_fst _#8 Hwf HofT Hjoin Hsplit Hofc Hofe HfstM) as Heqc.
so (snd_formation _#7 Hwf HofM Hsnd Hsplit HfstM) as Hofe'.
eapply oft_equiv; eauto; [].
apply eqc_symm; [].
so (split_formation _#4 HofT Hsplit) as (_ & Hoft).
eapply funct_cn_type; eauto; done.
Qed.


Lemma snd_join_halt_iff :
  forall T k t c e M e',
    ofs nil T
    -> split T k t
    -> ofc nil c k
    -> oft nil e (subst1 c t)
    -> join T c e M
    -> snd T M e'
    -> (thalt nil e <-> thalt nil e').
Proof.
intros T k t c e M e' HofT Hsplit Hofc Hofe Hjoin Hsnd.
transitivity (mhalt nil M).
  eapply join_halt_iff; eauto; done.

  so (join_formation _#7 wf_nil HofT Hjoin Hsplit Hofc Hofe) as HofM.
  eapply snd_halt_iff; eauto; done.
Qed.


(* The value restriction makes this lemma possible. *)
Lemma papp_halt :
  forall k t e c,
    oft nil e (cn_all k t)
    -> thalt nil e
    -> thalt nil (tm_papp e c).
Proof.
intros k t e c Hof Hhalte.
destruct Hhalte as (v & Hsteps & Hval).
so (preservations_tm _#4 wf_nil Hof Hsteps) as Hofv.
invert (Progress.canon_tm _ _ Hofv Consistent.similar_all Hval); [].
intros k' e' <-.
so (plam_oft_inversion_all _#5 wf_nil Hofv) as (_ & _ & Hval').
exists (subst1 c e').
split.
  #2 eapply star_trans.
    apply (star_map' _ _ (fun z => tm_papp z _)); eauto with dynamic; done.

    apply star_one; apply tstep_papp2; done.

  apply svalue_tvalue; [].
  apply subst_svalue; auto; done.
Qed.


Lemma snd_join_inverse :
  forall G T k t c e M e',
    ofs G T
    -> split T k t
    -> ofc G c k
    -> oft G e (subst1 c t)
    -> join T c e M
    -> snd T M e'
    -> ceqt G e e' (subst1 c t).
Proof.
cut (forall T k t c e M e',
       ofs nil T
       -> split T k t
       -> ofc nil c k
       -> oft nil e (subst1 c t)
       -> join T c e M
       -> snd T M e'
       -> ceqt nil e e' (subst1 c t)).
  intro Hprop.
  intros G T k t c e M e' HofT Hsplit Hofc Hofe Hjoin Hsnd.
  apply ceqt_with_wf; intro Hwf; [].
  so (snd_join_formation _#8 Hwf HofT Hsplit Hofc Hofe Hjoin Hsnd) as Hofe'.
  eapply closed_instances_ceqt; eauto; [].
  intros s Hs.
  replsub (subst s (subst1 c t)) with (subst1 (subst s c) (subst (under 1 s) t)).
  eapply Hprop; eauto using subst_ofs, subst_split, subst_ofc, subst_join, subst_snd, subof_aof_sof; [].
  simp_sub.
  so (subst_oft _#5 (subof_aof_dof _#3 Hs) Hofe) as H.
  simp_sub in H.
  exact H.
exploit
  (sg_ind_subst
     (fun T =>
        forall k t c e M e',
          ofs nil T
          -> split T k t
          -> ofc nil c k
          -> oft nil e (subst1 c t)
          -> join T c e M
          -> snd T M e'
          -> ceqt nil e e' (subst1 c t))) as Hprop.

(* one *)
intros k t c e M e' _ Hsplit Hofc Hofe Hjoin Hsnd.
so (snd_join_formation _#8 wf_nil ofs_one Hsplit Hofc Hofe Hjoin Hsnd) as Hofe'.
#2 apply (ceqt_conditional (thalt nil e)); auto.
  exact (snd_join_halt_iff _#7 ofs_one Hsplit Hofc Hofe Hjoin Hsnd ander).
intro Hhalte.
invert Hsplit; [].
intros <- <-.
invert Hjoin; [].
intros <-.
invert Hsnd; [].
intros <-.
clear Hsplit Hjoin Hsnd.
simp_sub in Hofe.
simp_sub in Hofe'.
destruct Hhalte as (v & Hsteps & Hval).
invert (Progress.canon_tm _ _ (preservations_tm _#4 wf_nil Hofe Hsteps) Consistent.similar_unit Hval); [].
intros <-.
simp_sub.
#2 apply (ceqt_trans _ _ tm_star).
  apply tsteps_ceqt; auto; done.

  apply ceqt_symm; [].
  apply tsteps_ceqt; auto; [].
  #2 eapply star_trans.
    apply (star_map' _ _ (fun z => tm_letm (md_lett z _) _)); eauto with dynamic; done.

    #2 eapply star_step.
      eauto with dynamic; done.

      simp_sub.
      #2 eapply star_step.
        eauto with static dynamic; done.

        simp_sub.
        apply star_refl; done.

(* stat *)
intros k ka t c e M e' Hofs Hsplit Hofc Hofe Hjoin Hsnd.
so (snd_join_formation _#8 wf_nil Hofs Hsplit Hofc Hofe Hjoin Hsnd) as Hofe'.
#2 apply (ceqt_conditional (thalt nil e)); auto.
  exact (snd_join_halt_iff _#7 Hofs Hsplit Hofc Hofe Hjoin Hsnd ander).
intro Hhalt.
invert Hofs; [].
intro Hofk.
invert Hsplit; [].
intros <- <-.
invert Hjoin; [].
intros <-.
invert Hsnd; [].
intros <-.
clear Hofs Hsplit Hjoin Hsnd.
simp_sub.
simp_sub in Hofe.
simp_sub in Hofe'.
destruct Hhalt as (v & Hsteps & Hval).
invert (Progress.canon_tm _ _ (preservations_tm _#4 wf_nil Hofe Hsteps) Consistent.similar_unit Hval); [].
intros <-.
simp_sub.
#2 apply (ceqt_trans _ _ tm_star).
  apply tsteps_ceqt; auto; done.

  apply ceqt_symm; [].
  apply tsteps_ceqt; auto; [].
  #2 eapply star_trans.
    apply (star_map' _ _ (fun z => tm_letm (md_lett z _) _)); eauto with dynamic; done.

    #2 eapply star_step.
      eauto with dynamic; done.

      simp_sub.
      #2 eapply star_step.
        eauto with static dynamic; done.

        simp_sub.
        apply star_refl; done.

(* dyn *)
intros t k ta c e M e' Hofs Hsplit Hofc Hofe Hjoin Hsnd.
so (snd_join_formation _#8 wf_nil Hofs Hsplit Hofc Hofe Hjoin Hsnd) as Hofe'.
#2 apply (ceqt_conditional (thalt nil e)); auto.
  exact (snd_join_halt_iff _#7 Hofs Hsplit Hofc Hofe Hjoin Hsnd ander).
intro Hhalt.
invert Hofs; [].
intros Hoft.
invert Hsplit; [].
intros <- <-.
invert Hjoin; [].
intros <-.
invert Hsnd; [].
intros <-.
clear Hofs Hsplit Hjoin Hsnd.
simp_sub; simp_sub in Hofe; simp_sub in Hofe'.
destruct Hhalt as (v & Hsteps & Hval).
#2 apply (ceqt_trans _ _ v).
  apply tsteps_ceqt; auto; done.

  apply ceqt_symm; apply tsteps_ceqt; auto; [].
  #2 eapply star_trans.
    apply (star_map' _ _ (fun z => tm_ext (md_dyn z))); eauto with dynamic; done.

    apply star_one; auto with dynamic; done.

(* pigen *)
intros T1 T2 IH1 IH2 k t c e M e' Hofs Hsplit Hofc Hofe Hjoin Hsnd.
so (snd_join_formation _#8 wf_nil Hofs Hsplit Hofc Hofe Hjoin Hsnd) as Hofe'.
#2 apply (ceqt_conditional (thalt nil e)); auto.
  exact (snd_join_halt_iff _#7 Hofs Hsplit Hofc Hofe Hjoin Hsnd ander).
intro Hhalte.
so (snd_join_halt_iff _#7 Hofs Hsplit Hofc Hofe Hjoin Hsnd andel Hhalte) as Hhalte'.
invert Hofs; clear Hofs; [].
intros k1 HofT1 Hfst1 HofT2.
invert Hsplit; clear Hsplit; [].
intros k1a k2 t1 t2 Hsplit1 Hsplit2 <- <-.
so (split_fsts_eq _#4 Hsplit1 Hfst1); subst k1a.
so (split_fsts _#3 Hsplit2) as Hfst2.
so (join_halt_iff _#6 (split_pigen Hsplit1 Hsplit2) Hofe Hjoin andel Hhalte) as HhaltM.
simp_sub; simp_sub in Hofe; simp_sub in Hofe'.
#2 apply ceqt_all_ext; auto.
  split; intros _; assumption.
intros b Hofb.
simp_sub.
#4 apply ceqt_arrow_ext.
  relquest.
    eapply oft_papp; eauto; done.

    simp_sub.
    reflexivity.

  relquest.
    eapply oft_papp; eauto; done.

    simp_sub.
    reflexivity.

  split; intro; eapply papp_halt; eauto; done.
intros v Hofv Hvalv.
clear HhaltM.
invert Hjoin; clear Hjoin; [].
intros e1 M2 Hsnd1 Hjoin2 <-.
invert Hsnd; clear Hsnd; [].
intros k1a t1a k2a t2a M1 e2 Hsplit1a Hsplit2a Hjoin1 Hsnd2 <-.
so (split_fun _#5 Hsplit1 Hsplit1a) as (<- & <-).
so (split_fun _#5 Hsplit2 Hsplit2a) as (<- & <-).
clear Hsplit1a Hsplit2a.
simp_sub in Hofe.
simp_sub.
apply ceqt_symm; [].
#2 apply reqt_ceqt.
  eapply oft_app; eauto; [].
  relquest.
    eapply oft_papp; eauto; done.

    simp_sub.
    reflexivity.
clear Hofe' Hhalte'.
so (subst_snd _#3 (dot (var 0) (dot nonsense (dot nonsense (sh 3)))) Hsnd1) as H; simp_sub in H.
so (snd_fun _#4 Hsnd1 H) as Heqe1; clear H.
so (subst_join _#4 (dot (var 0) (dot (var 1) (dot nonsense (dot nonsense (sh 4))))) Hjoin1) as H; simp_sub in H.
so (join_fun _#5 Hjoin1 H) as HeqM1; clear H.
so (subst_snd _#3 (dot (var 0) (dot nonsense (dot nonsense (dot (var 3) (dot nonsense (dot nonsense (sh 6))))))) Hsnd2) as H; simp_sub in H.
so (snd_fun _#4 Hsnd2 H) as Heqe2; clear H.
so (subst_join _#4 (dot (var 0) (dot (var 1) (dot nonsense (dot (var 3) (dot nonsense (sh 5)))))) Hjoin2) as H; simp_sub in H.
so (join_fun _#5 Hjoin2 H) as HeqM2; clear H.
rewrite -> Heqe1, Heqe2, HeqM1, HeqM2; [].
clear Heqe1 Heqe2 HeqM1 HeqM2.
simp_sub.
#2 eapply reqt_trans.
  apply reqt_app; [| apply reqt_refl; done].
  #2 eapply reqt_trans.
    apply reqt_papp; [].
    #2 eapply reqt_trans.
      apply reqt_letm; [].
      apply reqm_lett_beta; auto; done.
    simp_sub.
    apply tsteps_reqt; [].
    apply star_one; eapply tstep_letm2; eauto with static dynamic; done.
  simp_sub.
  apply tsteps_reqt; apply star_one; apply tstep_papp2; done.
simp_sub.
clear Hhalte.
#2 eapply reqt_trans.
  apply tsteps_reqt; apply star_one; apply tstep_app3; auto; done.
simp_sub.
so (subst_join _#4 (dot v (dot b (dot nonsense (dot nonsense id)))) Hjoin1) as Hjoin1x; simp_sub in Hjoin1x.
so (join_fst_o _#7 wf_nil HofT1 Hjoin1x Hsplit1 Hofb Hofv) as (b' & HfstM1x & Heqb).
#2 eapply reqt_trans.
  apply reqt_letm; [].
  #2 eapply reqm_trans.
    #4 eapply reqm_appgn_beta_fstm_eqc.
      exact (join_halt_iff _#6 Hsplit1 Hofv Hjoin1x andel (tvalue_thalt _ _ Hvalv)).
  
      exact HfstM1x.

      exact Hfst1.

      exact (eqc_symm Heqb).
  simp_sub.
  apply reqm_unpack; [].
  #2 apply reqt_app.
    eapply ceqt_reqt; [].
    apply ceqt_comp; [].
    #2 eapply tcc_papp.
      apply ceqt_refl; eauto; done.

      eapply eqc_refl; exact Hofb.

    eapply ceqt_reqt; [].
    clear Hofe.
    apply ceqt_symm; [].
    so (IH1 id) as IH1'; clear IH1; simp_sub in IH1'.
    eapply (IH1' _ _ b v); eauto; [].
    so (subst_snd _#3 (dot (subst (dot v (dot b (dot nonsense (dot nonsense (id))))) M1) (dot nonsense (dot nonsense id))) Hsnd1) as Hsnd1x; simp_sub in Hsnd1x.
    exact Hsnd1x.
clear IH1 HfstM1x Hjoin1x b' HfstM1x Heqb.
apply (ceqt_reqt _#3 (cn_exists (subst1 b k2) (subst (under 1 (dot b id)) t2))); [].
assert (oft nil (tm_app (tm_papp e b) v) (cn_exists (subst1 b k2) (subst (under 1 (dot b id)) t2))) as Hofebv.
  #2 eapply oft_app.
    relquest.
      eapply oft_papp; eauto; done.

      simp_sub; reflexivity.

    exact Hofv.
clear Hofe.
assert (oft nil
          (tm_letm
             (md_unpack (tm_app (tm_papp e b) v)
                (subst
                   (dot (var 0)
                      (dot (var 1)
                         (dot nonsense
                            (dot (subst (sh 2) b) (dot nonsense (sh 2)))))) M2)
                (subst1 b T2))
             (tm_pack (var 1)
                (subst
                   (dot (var 0)
                      (dot nonsense
                         (dot nonsense
                            (dot (subst (sh 2) b)
                               (dot nonsense (dot nonsense (sh 2))))))) e2)
                (subst (dot (subst (sh 2) b) (sh 2)) k2)
                (subst (dot (var 0) (dot (subst (sh 3) b) (sh 3))) t2)))
          (cn_exists (subst1 b k2) (subst (under 1 (dot b id)) t2))) as Hofbig.
  clear IH2 Hvalv.
  so (split_formation _#4 HofT2 Hsplit2) as (Hofk2 & Hoft2).
  #4 eapply oft_letm.
    #2 eapply ofm_unpack; eauto.
      simp_sub.
      apply ofm_forget; [].
      so (subst_join _#4 (dot (var 0) (dot (var 1) (dot nonsense (dot (subst (sh 2) b) (dot nonsense (sh 2)))))) Hjoin2) as Hjoin2x; simp_sub in Hjoin2x.
      #4 eapply join_formation; eauto using subst_split.
        #2 apply wf_tm.
          apply wf_cn; [exact wf_nil |].
          eapply subst1_ofk; eauto; done.

          eapply subst_ofc_type; eauto; [].
          prove_subof; [].
          apply weaken1_ofc; auto; done.

        eapply subst_ofs; eauto; [].
        prove_subof; [].
        apply weaken2_ofc; auto; done.

        ofvar; done.

        ofvar; done.

      eapply subst1_ofs; eauto; done.

    eapply subst_fsts; eauto; done.

    simp_sub.
    #3 apply oft_pack.
      ofvar; done.

      simp_sub.
      so (subst_snd _#3 (dot (var 0) (dot nonsense (dot nonsense (dot (subst (sh 2) b) (dot nonsense (dot nonsense (sh 2))))))) Hsnd2) as Hsnd2x; simp_sub in Hsnd2x.
      relquest.
        #3 eapply snd_formation; eauto using subst_split.
          replsub (subst (dot (shift1 b) sh1) T2) with (shift1 (subst1 b T2)).
          apply wf_md; [exact wf_nil | |].
            eapply subst1_ofs; eauto; done.

            apply subst_fsts; eauto; done.

          ofvar; done.

          ofvar; done.

        simp_sub.
        reflexivity.

      eapply subst_ofc_type; eauto; [].
      prove_subof; [].
      eapply subst_ofc; eauto; [].
      prove_subof; done.

    #2 apply ofc_exists.
      eapply subst1_ofk; eauto; done.

      eapply subst_ofc_type; eauto; [].
      simp_sub.
      prove_subof; [].
      apply weaken1_ofc; auto; done.
#2 apply (ceqt_conditional (thalt nil (tm_app (tm_papp e b) v))); auto.
  intro Hhalt.
  eapply munpack_halt_inversion'; [].
  eapply letm_halt_inversion'; eauto; done.
intro Hhalt.
destruct Hhalt as (w & Hstepsebv & Hvalw).
so (preservations_tm _#4 wf_nil Hofebv Hstepsebv) as Hofw.
invert (Progress.canon_tm _ _ Hofw Consistent.similar_exists Hvalw); [].
intros a u k t <-.
invert Hvalw; clear Hvalw; [].
intros Hvalu.
so (pack_oft_inversion_exists _#7 wf_nil Hofw) as (Heqk & Heqt & Hofa & Hofu).
clear Hofw.
simp_sub in Hofu.
eapply (ceqt_trans _ _ (tm_pack a u k t)); [| apply ceqt_symm; eapply tsteps_ceqt; eauto; done].
apply reqt_ceqt; auto; [].
clear Hofbig.
#2 eapply reqt_trans.
  apply reqt_letm; [].
  #2 eapply reqm_trans.
    apply reqm_unpack; [].
    apply tsteps_reqt; eauto; done.
  apply reqm_unpack_beta; auto using tvalue_thalt; done.
simp_sub.
so (split_formation _#4 HofT2 Hsplit2) as (Hofk2 & Hoft2).
so (subst_join _#4 (dot u (dot a (dot nonsense (dot b (dot nonsense id))))) Hjoin2) as Hjoin2x; simp_sub in Hjoin2x.
#2 sor (refine (join_fst_o _#7 wf_nil (subst1_ofs _#4 Hofb HofT2) Hjoin2x (subst_split _#4 Hsplit2) Hofa _)) as (a' & HfstM2x & Heqa).
  simp_sub.
  exact Hofu.
#2 eapply reqt_trans.
  apply reqt_letm_beta; eauto; [].
  refine (join_halt_iff _#6 (subst_split _#4 Hsplit2) _ Hjoin2x andel (tvalue_thalt _ _ Hvalu)); [].
  simp_sub.
  eapply oft_equiv; eauto; [].
  eapply seq_ofc_type; eauto using wf_nil; [].
  prove_subrel; eauto with static; done.
simp_sub.
#2 eapply reqt_trans.
  apply reqt_pack; [].
  eapply ceqt_reqt; [].
  apply ceqt_symm; [].
  #3 eapply (IH2 (dot b id)); eauto using subst_split.
    eapply subst1_ofs; eauto; done.

    simp_sub.
    exact Hofu.

    so (subst_snd _#3 (dot (subst (dot u (dot a (dot nonsense (dot b (dot nonsense id))))) M2) (dot nonsense (dot nonsense (dot b (dot nonsense (dot nonsense id)))))) Hsnd2) as Hsnd2x; simp_sub in Hsnd2x.
    exact Hsnd2x.
#3 apply reqt_pack_annot.
  apply eqc_symm; auto; done.

  apply eqk_symm; auto; done.

  simp_sub in Heqt.
  apply eqc_symm; auto; done.

(* piapp *)
intros T1 T2 IH1 IH2 k t c e M e' Hofs Hsplit Hofc Hofe Hjoin Hsnd.
so (snd_join_formation _#8 wf_nil Hofs Hsplit Hofc Hofe Hjoin Hsnd) as Hofe'.
#2 apply (ceqt_conditional (thalt nil e)); auto.
  exact (snd_join_halt_iff _#7 Hofs Hsplit Hofc Hofe Hjoin Hsnd ander).
intro Hhalte.
so (snd_join_halt_iff _#7 Hofs Hsplit Hofc Hofe Hjoin Hsnd andel Hhalte) as Hhalte'.
invert Hofs; clear Hofs; [].
intros k1 HofT1 Hfst1 HofT2.
invert Hsplit; clear Hsplit; [].
intros k1a k2 t1 t2 Hsplit1 Hsplit2 <- <-.
so (split_fsts_eq _#4 Hsplit1 Hfst1); subst k1a.
so (split_fsts _#3 Hsplit2) as Hfst2.
so (join_halt_iff _#6 (split_piapp Hsplit1 Hsplit2) Hofe Hjoin andel Hhalte) as HhaltM.
simp_sub; simp_sub in Hofe; simp_sub in Hofe'.
#2 apply ceqt_all_ext; auto.
  split; intros _; assumption.
intros b Hofb.
simp_sub.
#4 apply ceqt_arrow_ext.
  relquest.
    eapply oft_papp; eauto; done.

    simp_sub.
    reflexivity.

  relquest.
    eapply oft_papp; eauto; done.

    simp_sub.
    reflexivity.

  split; intro; eapply papp_halt; eauto; done.
clear Hhalte' HhaltM.
intros v Hofv Hvalv.
so (can_snd (subst (sh 2) T1) (var 0) (subst_hsg _ _ (ofs_hsg _ _ HofT1))) as (e1 & Hsnd1).
so (can_join (subst (sh 2) T1) (var 1) (var 0) (subst_hsg _ _ (ofs_hsg _ _ HofT1))) as (M1 & Hjoin1).
so (can_snd (subst (sh 2) T2) (var 0) (subst_hsg _ _ (ofs_hsg _ _ HofT2))) as (e2 & Hsnd2).
so (can_join (subst (sh 2) T2) (var 1) (var 0) (subst_hsg _ _ (ofs_hsg _ _ HofT2))) as (M2 & Hjoin2).
invert Hjoin; clear Hjoin; [].
intros f N Hsnd1x Hjoin2x <-.
so (subst_snd _#3 (under 2 (sh 1)) Hsnd1) as Hsnd1x'; simp_sub in Hsnd1x'.
so (snd_fun _#4 Hsnd1x Hsnd1x'); subst f.
clear Hsnd1x Hsnd1x'.
so (subst_join _#4 (dot (tm_app (tm_papp (var 2) (var 1)) (subst (dot (var 0) (dot (var 1) (sh 3))) e1)) (dot (cn_app (subst (sh 3) c) (var 1)) (dot (var 1) (sh 3)))) Hjoin2) as Hjoin2x'; simp_sub in Hjoin2x'.
so (join_fun _#5 Hjoin2x Hjoin2x'); subst N.
clear Hjoin2x Hjoin2x'.
invert Hsnd; clear Hsnd; [].
intros k1a t1a N f Hsplit1a Hjoin1x Hsnd2x <-.
so (split_fun _#5 Hsplit1 Hsplit1a) as (<- & <-); clear Hsplit1a.
so (subst_join _#4 (under 2 (sh 2)) Hjoin1) as Hjoin1x'; simp_sub in Hjoin1x'.
so (join_fun _#5 Hjoin1x Hjoin1x'); subst N.
clear Hjoin1x Hjoin1x'.
so (subst_snd _#3 (dot (md_appap (var 2) (subst (dot (var 0) (dot (var 1) (sh 4))) M1)) (dot nonsense (dot (var 1) (sh 4)))) Hsnd2) as Hsnd2x'; simp_sub in Hsnd2x'.
so (snd_fun _#4 Hsnd2x Hsnd2x'); subst f.
clear Hsnd2x Hsnd2x'.
apply ceqt_symm; [].
#2 apply reqt_ceqt.
  eapply oft_app; eauto; [].
  relquest.
    eapply oft_papp; eauto; done.

    simp_sub.
    reflexivity.
clear Hofe'.
#2 eapply reqt_trans.
  apply reqt_app; [| apply reqt_refl; done].
  #2 eapply reqt_trans.
    apply reqt_papp; [].
    #2 eapply reqt_trans.
      apply reqt_letm; [].
      apply reqm_lett_beta; auto; done.
    clear Hhalte.
    simp_sub.
    apply reqt_letm_beta_nofst; auto with dynamic; [].
    simp_sub; reflexivity.
  simp_sub.
  apply tsteps_reqt; apply star_one; apply tstep_papp2; done.
clear Hhalte.
simp_sub.
#2 eapply reqt_trans.
  apply reqt_app_beta; auto using tvalue_thalt; done.
simp_sub.
apply (ceqt_reqt _#3 (subst (dot (cn_app c b) (dot b id)) t2)); [].
#2 eapply ceqt_trans.
  apply ceqt_symm; [].
  so (subst_join _#4 (dot (tm_app (tm_papp e b) (subst (dot (subst (dot v (dot b id)) M1) (dot b id)) e1)) (dot (cn_app c b) (dot b id))) Hjoin2) as Hjoin2x; simp_sub in Hjoin2x.
  #3 sor (refine (join_fst_o _#7 wf_nil (subst1_ofs _#4 Hofb HofT2) Hjoin2x (subst_split _#4 Hsplit2) _ _)) as (cb & HfstM2x & Heqcb).
    eapply ofc_app; eauto; done.
  
    simp_sub.
    #2 eapply oft_app.
      relquest.
        eapply oft_papp; eauto; done.

        simp_sub; reflexivity.

      so (subst_join _#4 (dot v (dot b id)) Hjoin1) as Hjoin1x; simp_sub in Hjoin1x.
      so (subst_snd _#3 (dot (subst (dot v (dot b id)) M1) (dot b id)) Hsnd1) as Hsnd1x; simp_sub in Hsnd1x.
      eapply snd_join_formation; eauto using wf_nil; done.
  #2 apply ceqt_comp; eapply tcc_equiv.
    #6 eapply (snd_ceq nil (subst1 b T2) _ _ _
                 (md_appap
                   (md_lamap T1
                      (subst
                         (dot
                            (tm_app (tm_papp (subst (sh 2) e) (var 1))
                               (subst (dot (var 0) (dot (var 1) (sh 2))) e1))
                            (dot (cn_app (subst (sh 2) c) (var 1))
                               (dot (var 1) (sh 2)))) M2))
                   (subst (dot v (dot b id)) M1))).
      exact wf_nil.
  
      apply subst_split; eauto; done.
  
      apply ceqm_symm; [].
      so (subst_join _#4 (dot v (dot b id)) Hjoin1) as Hjoin1x; simp_sub in Hjoin1x.
      so (join_fst_o _#7 wf_nil HofT1 Hjoin1x Hsplit1 Hofb Hofv) as (b' & HfstM1x & Heqb).
      #5 eapply ceqm_appap_beta_fstm_eqc.
        clear IH1 IH2 Hjoin2x.
        #2 eapply ofm_subsume.
          #3 eapply ofm_appap.
            eapply ofm_lamap; eauto; [].
            relquest.
              so (subst_join _#4 (dot (tm_app (tm_papp (subst (sh 2) e) (var 1)) (subst (dot (var 0) (dot (var 1) (sh 2))) e1)) (dot (cn_app (subst (sh 2) c) (var 1)) (dot (var 1) (sh 2)))) Hjoin2) as Hjoin2x; simp_sub in Hjoin2x.
              #5 eapply join_formation; eauto.
                apply wf_md; auto using wf_nil; done.

                rewrite -> subst_dot1_sh; [].
                apply weaken1_ofs; auto; done.

                apply subst_split; eauto; done.

                relquest.
                  #2 eapply ofc_app.
                    relquest.
                      apply weaken2_ofc; eauto; done.

                      simp_sub; reflexivity.

                    ofvar; done.

                  simp_sub; reflexivity.

                #2 eapply oft_app.
                  relquest.
                    #2 eapply oft_papp.
                      relquest.
                        apply weaken2_oft; eauto; done.

                        simp_sub; reflexivity.

                      ofvar; done.

                    simp_sub; reflexivity.

                  rewrite -> subst_dot01_sh; [].
                  replsub (subst (dot (var 1) (sh 2)) t1) with (subst1 (var 1) (subst (under 1 (sh 2)) t1)).
                  #4 eapply snd_formation; eauto.
                    apply wf_md; auto using wf_nil; done.

                    ofvar; done.

                    apply subst_split; eauto; done.

                    ofvar; done.

              rewrite -> subst_dot1_sh; [].
              reflexivity.

            eapply join_formation; eauto using wf_nil; done.

            exact HfstM1x.

          apply subs_refl; [].
          apply eqs_symm; [].
          eapply funct_sg; eauto using wf_nil; done.

        exact (join_halt_iff _#6 Hsplit1 Hofv Hjoin1x andel (tvalue_thalt _ _ Hvalv)).
  
        exact HfstM1x.
  
        exact Hfst1.
  
        apply eqc_symm; exact Heqb.
  
      simp_sub.
      exact HfstM2x.
  
      simp_sub.
      so (subst_snd _#3 (dot (subst (dot (tm_app (tm_papp e b) (subst (dot (subst (dot v (dot b id)) M1) (dot b id)) e1)) (dot (cn_app c b) (dot b id))) M2) (dot nonsense (dot b id))) Hsnd2) as Hsnd2x; simp_sub in Hsnd2x.
      exact Hsnd2x.
  
      simp_sub.
      so (subst_snd _#3 (dot (md_appap (md_lamap T1 (subst (dot (tm_app (tm_papp (subst (sh 2) e) (var 1)) (subst (dot (var 0) (dot (var 1) (sh 2))) e1)) (dot (cn_app (subst (sh 2) c) (var 1)) (dot (var 1) (sh 2)))) M2)) (subst (dot v (dot b id)) M1)) (dot nonsense (dot b id))) Hsnd2) as Hsnd2x; simp_sub in Hsnd2x.
      exact Hsnd2x.

    simp_sub.
    so (split_formation _#4 HofT2 Hsplit2) as (_ & Hoft2).
    eapply seq_ofc_type; eauto using wf_nil; [].
    prove_subrel; eauto with static; done.
so (IH1 id) as IH1'; simp_sub in IH1'; clear IH1.
so (subst_join _#4 (dot v (dot b id)) Hjoin1) as Hjoin1x; simp_sub in Hjoin1x.
so (subst_snd _#3 (dot (subst (dot v (dot b id)) M1) (dot b id)) Hsnd1) as Hsnd1x; simp_sub in Hsnd1x.
so (IH1' _#6 HofT1 Hsplit1 Hofb Hofv Hjoin1x Hsnd1x) as Hceq1.  
clear IH1' Hsnd1x Hjoin1x.
so (subst_join _#4 (dot (tm_app (tm_papp e b) v) (dot (cn_app c b) (dot b id))) Hjoin2) as Hjoin2x; simp_sub in Hjoin2x.
so (subst_join _#4 (dot (tm_app (tm_papp e b) (subst (dot (subst (dot v (dot b id)) M1) (dot b id)) e1)) (dot (cn_app c b) (dot b id))) Hjoin2) as Hjoin2x'; simp_sub in Hjoin2x'.
#4 sor (refine (join_ceq _#10 wf_nil _ (subst_split _#4 Hsplit2) _ _ Hjoin2x Hjoin2x')) as Hceqm; clear Hjoin2x'.
  eapply subst1_ofs; eauto; done.

  apply eqc_refl; [].
  eapply ofc_app; eauto; done.

  simp_sub.
  apply ceqt_comp; [].
  #2 eapply tcc_app.
    apply ceqt_refl; [].
    relquest.
      eapply oft_papp; eauto; done.

      simp_sub; reflexivity.

    exact Hceq1.
clear Hceq1.
#4 sor (refine (join_fst_o _#7 wf_nil _ Hjoin2x (subst_split _#4 Hsplit2) _ _)) as (cb & HfstM2x & Heqcb).
  eapply subst1_ofs; eauto; done.

  eapply ofc_app; eauto; done.

  simp_sub.
  eapply oft_app; eauto; [].
  relquest.
    eapply oft_papp; eauto; done.

    simp_sub; reflexivity.
clear Hjoin2x.
so (subst_snd _#3 (dot (subst (dot (tm_app (tm_papp e b) v) (dot (cn_app c b) (dot b id))) M2) (dot nonsense (dot b id))) Hsnd2) as Hsnd2x; simp_sub in Hsnd2x.
so (subst_snd _#3 (dot (subst (dot (tm_app (tm_papp e b) (subst (dot (subst (dot v (dot b id)) M1) (dot b id)) e1)) (dot (cn_app c b) (dot b id))) M2) (dot nonsense (dot b id))) Hsnd2) as Hsnd2x'; simp_sub in Hsnd2x'.
so (snd_ceq _#9 wf_nil (subst_split _#4 Hsplit2) Hceqm HfstM2x Hsnd2x Hsnd2x') as Hceqt.
clear Hceqm HfstM2x Hsnd2x Hsnd2x'.
simp_sub in Hceqt.
#2 eapply ceqt_trans.
  #2 apply ceqt_comp; eapply tcc_equiv.
    apply ceqt_symm; exact Hceqt.

    so (split_formation _#4 HofT2 Hsplit2) as (_ & Hoft2).
    eapply seq_ofc_type; eauto using wf_nil; [].
    prove_subrel; auto with static; done.
clear cb Heqcb Hceqt.
replsub (subst (dot (cn_app c b) (dot b id)) t2) with (subst1 (cn_app c b) (subst (under 1 (dot b id)) t2)).
apply ceqt_symm; [].
#6 eapply (IH2 (dot b id)).
  eapply subst1_ofs; eauto; done.

  apply subst_split; eauto; done.

  eapply ofc_app; eauto; done.

  simp_sub.
  eapply oft_app; eauto; [].
  relquest.
    eapply oft_papp; eauto; done.

    simp_sub; reflexivity.

  so (subst_join _#4 (dot (tm_app (tm_papp e b) v) (dot (cn_app c b) (dot b id))) Hjoin2) as Hjoin2x; simp_sub in Hjoin2x.
  exact Hjoin2x.

  so (subst_snd _#3 (dot (subst (dot (tm_app (tm_papp e b) v) (dot (cn_app c b) (dot b id))) M2) (dot nonsense (dot b id))) Hsnd2) as Hsnd2x; simp_sub in Hsnd2x.
  exact Hsnd2x.

(* sigma *)
intros T1 T2 IH1 IH2 k t c e M e' Hofs Hsplit Hofc Hofe Hjoin Hsnd.
so (snd_join_formation _#8 wf_nil Hofs Hsplit Hofc Hofe Hjoin Hsnd) as Hofe'.
#2 apply (ceqt_conditional (thalt nil e)); eauto.
  exact (snd_join_halt_iff _#7 Hofs Hsplit Hofc Hofe Hjoin Hsnd ander).
intro Hhalte.
invert Hofs; clear Hofs; [].
intros k1 HofT1 Hfst1 HofT2.
invert Hsplit; clear Hsplit; [].
intros k1a k2 t1 t2 Hsplit1 Hsplit2 <- <-.
so (split_fsts_eq _#4 Hsplit1 Hfst1); subst k1a.
simp_sub.
so (split_fsts _#3 Hsplit2) as Hfst2.
so (ofs_fst _#3 HofT2 Hfst2) as Hofk2.
so (split_formation _#4 HofT1 Hsplit1) as (_ & Hoft1).
invert Hjoin; clear Hjoin; [].
intros M1 M2 Hjoin1 Hjoin2 <-.
invert Hsnd; clear Hsnd; [].
intros e1 e2 Hsnd1 Hsnd2 <-.
simp_sub in Hofe.
simp_sub in Hofe'.
#2 eapply ceqt_trans.
  eapply ceqt_prod_eta; eauto; done.
apply ceqt_symm; [].
apply reqt_ceqt; auto; [].
clear Hofe'.
#2 eapply reqt_trans.
  apply reqt_letm; [].
  apply reqm_lett_beta; auto; done.
simp_sub.
so (subst_join _#4 (dot e id) Hjoin1) as Hjoin1x; simp_sub in Hjoin1x.
so (subst_join _#4 (dot e id) Hjoin2) as Hjoin2x; simp_sub in Hjoin2x.
so (join_fst_o _#7 wf_nil HofT1 Hjoin1x Hsplit1 (ofc_pi1 Hofc) (oft_pi1 Hofe)) as (b1 & HfstM1x & Heqb1).
so (join_halt_iff _#6 Hsplit1 (oft_pi1 Hofe) Hjoin1x andel (thalt_pi1 _#3 Hofe Hhalte)) as HhaltM1x.
#2 sor (refine (join_halt_iff _#6 (subst_split _#4 Hsplit2) _ Hjoin2x andel (thalt_pi2 _#3 Hofe Hhalte))) as HhaltM2x.
  simp_sub.
  eapply oft_pi2; eauto; done.
so (join_formation _#7 wf_nil HofT1 Hjoin1x Hsplit1 (ofc_pi1 Hofc) (oft_pi1 Hofe)) as HofM1x.
#2 sor (refine (join_formation _#7 wf_nil (subst1_ofs _#4 (ofc_pi1 Hofc) HofT2) Hjoin2x (subst_split _#4 Hsplit2) (ofc_pi2 Hofc) _)) as HofM2x.
  simp_sub.
  eapply oft_pi2; eauto; done.
#2 sor (refine (join_fst_o _#7 wf_nil (subst1_ofs _#4 (ofc_pi1 Hofc) HofT2) Hjoin2x (subst_split _#4 Hsplit2) (ofc_pi2 Hofc) _)) as (b2 & HfstM2x & Heqb2).
  simp_sub; exact (oft_pi2 Hofe).
#2 eapply reqt_trans.  
  #2 apply reqt_letm_beta.
    apply mhalt_pair; auto; done.
      
    eapply fstm_pair; eauto; done.
simp_sub.
apply (ceqt_reqt _#3 (cn_prod (subst1 (cn_pi1 c) t1) (subst (dot (cn_pi2 c) (dot (cn_pi1 c) id)) t2))); [].
#2 apply ceqt_comp; apply tcc_pair.
  clear IH2.
  so (subst_snd _#3 (dot (md_pair (subst1 e M1) (subst1 e M2)) (dot (cn_pair b1 b2) id)) Hsnd1) as Hsnd1x; simp_sub in Hsnd1x.
  #6 exploit (snd_ceq_o nil T1 k1 t1 (md_pi1 (md_pair (subst1 e M1) (subst1 e M2))) (subst1 e M1) (cn_pi1 (cn_pair b1 b2)) (subst (dot (md_pair (subst1 e M1) (subst1 e M2)) (dot (cn_pair b1 b2) id)) e1)).
    exact wf_nil.

    exact Hsplit1.

    eapply ceqm_pi1_beta; eauto; done.
    
    eauto with static; done.

    exact Hsnd1x.
  destruct H as (e1' & Hsnd1x' & Hceq1).
  #2 eapply ceqt_trans.
    #2 apply ceqt_comp; eapply tcc_equiv.
      exact Hceq1.

      eapply funct_cn_type; eauto using wf_nil; [].
      eapply eqc_symm; [].
      eapply eqc_pi1; [].
      #2 apply (@eqc_trans _ _ (cn_pair (cn_pi1 c) (cn_pi2 c))).
        #3 eapply eqc_extsigma.
          eapply eqc_symm; [].
          eapply eqc_beta1; eauto with static; done.

          eapply eqc_symm; [].
          eapply eqc_beta2; eauto with static; done.

          exact Hofk2.

        apply eqc_pair; eauto; done.
  clear Hceq1.
  apply ceqt_symm; [].
  so (IH1 id) as IH1'; simp_sub in IH1'; clear IH1.
  eapply IH1'; eauto with static; done.

  clear IH1.
  so (can_snd _ (var 0) (subst_hsg (sh 2) _ (ofs_hsg _ _ HofT2))) as (f & Hsndf).
  so (subst_snd _#3 (dot (md_pi2 (var 0)) (dot (cn_pi2 (var 1)) (dot (cn_pi1 (var 1)) (sh 2)))) Hsndf) as Hsndf'; simp_sub in Hsndf'.
  so (snd_fun _#4 Hsndf' Hsnd2); subst e2.
  clear Hsndf'.
  simp_sub.
  #6 sor (refine (snd_formation (nil; cl_cn k1; cl_cn k2; cl_md (shift1 T2) (var 0)) (subst (sh 2) T2) (var 0)  _ _ _ _ _ _ _ _ _)) as Hoff.
    apply wf_md; eauto; [].
    so (ofs_fst _#3 HofT1 Hfst1) as Hofk1.
    apply wf_cn; auto using wf_nil; done.

    ofvar; done.

    exact Hsndf.

    apply subst_split; eauto; done.

    ofvar; done.
  simp_sub in Hoff.
  #3 sor (refine (funct_ceq_tm nil _ (dot (subst1 e M2) (dot b2 (dot (cn_pi1 c) id))) (dot (md_pi2 (md_pair (subst1 e M1) (subst1 e M2))) (dot (cn_pi2 (cn_pair b1 b2)) (dot (cn_pi1 (cn_pair b1 b2)) id))) _ _ wf_nil _ _ Hoff)) as Hceq2.
    apply wf_md; eauto; [].
    so (ofs_fst _#3 HofT1 Hfst1) as Hofk1.
    apply wf_cn; auto using wf_nil; done.

    so (eqc_reg _#4 wf_nil Heqb1) as (_ & Hofb1 & _).
    so (eqc_reg _#4 wf_nil Heqb2) as (_ & Hofb2 & _).
    #6 prove_subrel.
      eapply ofc_pi1; eauto; done.

      apply eqc_symm; [].
      #2 eapply eqc_trans.
        eapply eqc_beta1; eauto; done.

        apply eqc_symm; auto; done.

      exact Hofb2.

      apply eqc_symm; [].
      eapply eqc_beta2; eauto; done.

      apply ceqm_symm; [].
      eapply ceqm_pi2_beta; eauto; done.

      exact HfstM2x.
  simp_sub in Hceq2.
  #2 eapply ceqt_trans.
    apply ceqt_symm; [].
    #2 apply ceqt_comp; eapply tcc_equiv.
      exact Hceq2.

      so (split_formation _#4 (subst1_ofs _#4 (ofc_pi1 Hofc) HofT2) (subst_split _#4 Hsplit2)) as (_ & Hoft2).
      replsub (subst (dot b2 (dot (cn_pi1 c) id)) t2) with (subst1 b2 (subst (under 1 (dot (cn_pi1 c) id)) t2)).
      replsub (subst (dot (cn_pi2 c) (dot (cn_pi1 c) id)) t2) with (subst1 (cn_pi2 c) (subst (under 1 (dot (cn_pi1 c) id)) t2)).
      eapply funct_cn_type; eauto with static.
  apply ceqt_symm; [].
  replsub (subst (dot (cn_pi2 c) (dot (cn_pi1 c) id)) t2) with (subst1 (cn_pi2 c) (subst (under 1 (dot (cn_pi1 c) id)) t2)).
  #6 eapply (IH2 (dot (cn_pi1 c) id)).
    eapply subst1_ofs; eauto with static; done.

    apply subst_split; eauto; done.

    eapply ofc_pi2; eauto; done.

    simp_sub.
    eapply oft_pi2; eauto; done.

    exact Hjoin2x.

    so (subst_snd _#3 (dot (subst1 e M2) (dot b2 (dot (cn_pi1 c) id))) Hsndf) as Hsnd2x; simp_sub in Hsnd2x.
    exact Hsnd2x.

(* epilogue *)
intros T k t c e M e' HofT Hsplit Hofc Hofe Hjoin Hsnd.
eapply Hprop; eauto using ofs_hsg; done.
Qed.


Lemma snd_join_vars_inverse :
  forall G T k t c e N f,
    ofs G T
    -> split T k t
    -> ofc G c k
    -> oft G e (subst1 c t)
    -> join (subst (sh 2) T) (var 1) (var 0) N
    -> snd (subst sh1 T) (var 0) f
    -> ceqt G e (subst (dot (subst (dot e (dot c id)) N) id) f) (subst1 c t).
Proof.
intros G T k t c e N f HofT Hsplit Hofc Hofe Hjoin Hsnd.
so (subst_join _#4 (dot e (dot c id)) Hjoin) as Hjoinx; simp_sub in Hjoinx.
so (subst_snd _#3 (dot (subst (dot e (dot c id)) N) id) Hsnd) as Hsndx; simp_sub in Hsndx.
exact (snd_join_inverse _#8 HofT Hsplit Hofc Hofe Hjoinx Hsndx).
Qed.
